# The Help Class provides usage options to the command line for quick
# reference. The help class is also called when textigniter is called with
# no options or incorrect options.
class Textigniter::Help
  
  def initialize(args)
    STDOUT.puts "Usage:\r\n".yellow_on_black
    STDOUT.puts "   textigniter COMMAND [OPTION]\r\n".white_on_black
    # show build help
    build
    # show init help
    init
    # show scrub help
    scrub
  end
    
  # Build help
  def build
    STDOUT.puts "   textigniter build".bold.white_on_black
    STDOUT.puts "   Builds static output from the textigniter environment\r\n".yellow_on_black
  end
  
  # Init help
  def init
    STDOUT.puts "   textigniter init".bold.white_on_black
    STDOUT.puts "   Creates a new textigniter environment\r\n".yellow_on_black    
  end
  
  # Scruby help
  def scrub
    STDOUT.puts "   textigniter scrub".bold.white_on_black
    STDOUT.puts "   Deletes the textigniter environment\r\n".yellow_on_black
  end
  
end