class Textigniter::Plugins
  
  # parse through the hash
  def parse(h)
    # create a hash to store processed items
    @h = Hash.new
    # require plugins
    require_plugins(plugins)
    # load plugins
    splugin = load_plugins(plugins)
    # iterate through the hash
    h.each do |key, value|
      # check for plugin methods
      if splugin.has_key?(key)
        # pass the entire hash to parser
        # may have to rethink this if speed problems arise
        @h["#{key}"] = splugin["#{key}"].parse(h)
      else
        @h["#{key}"] = value
      end
    end
    # return the hash
    return @h
  end
  
  # gather a list of textigniter and custom plugins
  def plugins
    # textigniter plugins
    textigniter_plugins = Dir.glob("#{$gem_path}/textigniter/plugins/**/*.rb")
    # custom plugins
    custom_plugins = Dir.glob("#{$twd}/plugins/**/*.rb")
    # join plugins
    @plugins = textigniter_plugins | custom_plugins
  end
  
  # require the plugins for use
  def require_plugins(plugins)
    plugins.each do |plugin|
      # require the plugin
      require_relative plugin
    end
  end
  
  # load the plugins and return a super object
  def load_plugins(plugins)
    # create a hash to store plugins in
    splugin = Hash.new
    # iterate through list
    plugins.each do |plugin|
      # buld the class name
      classname = camelcase(File.basename(plugin, '.rb'))
      # load the class
      loaded_class = eval("Textigniter::Plugins::#{classname}").new
      # add it to splugin
      splugin["#{File.basename(plugin, '.rb')}"] = loaded_class
    end
    # return the super plugin
    return splugin
  end
  
  def camelcase(phrase)
    phrase.gsub!(/_/, ' ')
    phrase.gsub!(/\b\w/){$&.upcase}
    phrase.gsub!(/ /, '')
    return phrase
  end
    
end